<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_Core_Generator
{
    public static function generateKeys()
    {
        $success = true;
        $messages = [];

        if(!isset($_POST['keys_type'])) {
            $success = false;
        }

        $type = $_POST['keys_type'];

        if(empty($type) || $type === false) {
            $success = false;
            $messages[] = 'key_generator_error1';
            $messages[] = 'key_generator_error2';
        }

        if (!$success) {
            return ['success' => $success, 'messages' => $messages];
        }

        $generator = new \Verifone\Core\DependencyInjection\CryptUtils\RsaKeyGenerator();
        $resultGenerate = $generator->generate();

        if ($resultGenerate) {
            $resultStoreKey = Verifone_Keys::storeKeys($type, $generator->getPublicKey(), $generator->getPrivateKey());

            if($resultStoreKey === true) {
                $messages[] = 'keys_generator_success';
                return ['success' => $success, 'messages' => $messages];
            }

            $success = false;
            $messages[] = $resultStoreKey;

        } else {
            $success = false;
            $messages[] = 'key_generator_error1';
        }

        return ['success' => $success, 'messages' => $messages];

    }

}