<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */


class Verifone_Keys
{
    const STORAGE_KEY_LIVE_PUBLIC = 'payment_verifone_keys_live_public';
    const STORAGE_KEY_LIVE_PRIVATE = 'payment_verifone_keys_live_private';
    const STORAGE_KEY_TEST_PUBLIC = 'payment_verifone_keys_test_public';
    const STORAGE_KEY_TEST_PRIVATE = 'payment_verifone_keys_test_private';

    const STORAGE_KEY_DEFAULT_PRIVATE = 'demo-merchant-agreement-private.pem';
    const STORAGE_KEY_DEFAULT_PUBLIC = 'demo-merchant-agreement-public.pem';

    const STORAGE_KEY_GATEWAY_LIVE = 'verifone-e-commerce-live-public-key.pem';
    const STORAGE_KEY_GATEWAY_TEST = 'verifone-e-commerce-test-public-key.pem';

    public static function storeKeys($type, $publicKey, $privateKey)
    {
        $settingsObject = Verifone_Storage::getInstance()->getSettingModel();

        try {
            if ($type === 'live') {
                $settingsObject->editSetting(self::STORAGE_KEY_LIVE_PRIVATE, [self::STORAGE_KEY_LIVE_PRIVATE => $privateKey]);
                $settingsObject->editSetting(self::STORAGE_KEY_LIVE_PUBLIC, [self::STORAGE_KEY_LIVE_PUBLIC => $publicKey]);
            } else {
                $settingsObject->editSetting(self::STORAGE_KEY_TEST_PRIVATE, [self::STORAGE_KEY_TEST_PRIVATE => $privateKey]);
                $settingsObject->editSetting(self::STORAGE_KEY_TEST_PUBLIC, [self::STORAGE_KEY_TEST_PUBLIC => $publicKey]);
            }
        } catch (Exception $e) {
            return false;
        }

        return true;
    }

    public static function getLivePrivateKey()
    {
        return self::getKey(self::STORAGE_KEY_LIVE_PRIVATE);
    }

    public static function getLivePublicKey()
    {
        return self::getKey(self::STORAGE_KEY_LIVE_PUBLIC);
    }

    public static function getTestPrivateKey()
    {
        return self::getKey(self::STORAGE_KEY_TEST_PRIVATE);
    }

    public static function getTestPublicKey()
    {
        return self::getKey(self::STORAGE_KEY_TEST_PUBLIC);
    }

    protected static function getKey($type)
    {
        $settingsObject = Verifone_Storage::getInstance()->getSettingModel();
        return $settingsObject->getSettingValue($type);
    }
}