<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2018 Lamia Oy (https://lamia.fi)
 */

class Verifone_Observer
{
    public static function executeCheckOrderPaymentAction($order, $cron = false)
    {
        $result = Verifone_Payment::checkPaymentStatus($order, $cron);

        $language = Verifone_Storage::getInstance()->getLanguageModel();

        if ($result) {
            $message = sprintf($language->get('text_order_status_processing'), 'processing');
            $status = Verifone_Config::getInstance()->getOrderStatusSuccess();
        } elseif ($result === null) {
            $message = $language->get('text_order_status_pending');
            $status = Verifone_Config::getInstance()->getOrderStatusPendingPayment();
        } else {
            $message = $language->get('text_order_status_cancel');
            $status = Verifone_Config::getInstance()->getOrderStatusFail();
        }

        if (!$cron) {
            $note = $language->get('text_order_status_note_manually');
        } else {
            $note = $language->get('text_order_status_note_cron');
        }

        $return = [
            'message' => $note . '<br>' . $message,
            'status' => $status
        ];

        return $return;
    }
}