<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2017 Lamia Oy (https://lamia.fi)
 * @author    Szymon Nosal <simon@lamia.fi>
 */

class Verifone_Storage
{
    protected $_settingModel;
    protected $_languageModel;
    protected $_sessionModel;
    protected $_currencyModel;
    protected $_customFieldsModel;
    protected $_urlModel;
    protected $_orderModel;
    protected $_orderStatusesModel;
    protected $_verifoneModel;
    protected $_customerModel;
    protected $_db;
    protected $_verifoneOrderStatus;

    /**
     * @var Verifone_Storage $instance Singleton The reference the *Singleton* instance of this class
     */
    private static $instance;

    /**
     * Returns the *Singleton* instance of this class.
     *
     * @return Verifone_Storage Singleton The *Singleton* instance.
     */
    public static function getInstance()
    {
        if (null === self::$instance) {
            self::$instance = new self();
        }
        return self::$instance;
    }

    /**
     * Private clone method to prevent cloning of the instance of the
     * *Singleton* instance.
     *
     * @return void
     */
    private function __clone()
    {
    }

    /**
     * Private wakeup method to prevent unserializing of the *Singleton*
     * instance.
     *
     * @return void
     */
    private function __wakeup()
    {
    }

    /**
     * Protected constructor to prevent creating a new instance of the
     * *Singleton* via the `new` operator from outside of this class.
     */
    protected function __construct()
    {

    }

    /**
     * @return
     */
    public function getSettingModel()
    {
        return $this->_settingModel;
    }

    /**
     * @param  $settingModel
     */
    public function setSettingModel($settingModel)
    {
        $this->_settingModel = $settingModel;
    }

    /**
     * @return ModelLocalisationLanguage
     */
    public function getLanguageModel()
    {
        return $this->_languageModel;
    }

    /**
     * @param  $languageModel
     */
    public function setLanguageModel($languageModel)
    {
        $this->_languageModel = $languageModel;
    }

    /**
     * @return
     */
    public function getSessionModel()
    {
        return $this->_sessionModel;
    }

    /**
     * @param  $sessionModel
     */
    public function setSessionModel($sessionModel)
    {
        $this->_sessionModel = $sessionModel;
    }

    /**
     * @return
     */
    public function getCurrencyModel()
    {
        return $this->_currencyModel;
    }

    /**
     * @param  $currencyModel
     */
    public function setCurrencyModel($currencyModel)
    {
        $this->_currencyModel = $currencyModel;
    }

    /**
     * @return
     */
    public function getCustomFieldsModel()
    {
        return $this->_customFieldsModel;
    }

    /**
     * @param  $customFieldsModel
     */
    public function setCustomFieldsModel($customFieldsModel)
    {
        $this->_customFieldsModel = $customFieldsModel;
    }

    /**
     * @return
     */
    public function getUrlModel()
    {
        return $this->_urlModel;
    }

    /**
     * @param  $urlModel
     */
    public function setUrlModel($urlModel)
    {
        $this->_urlModel = $urlModel;
    }

    /**
     * @return
     */
    public function getOrderModel()
    {
        return $this->_orderModel;
    }

    /**
     * @param  $orderModel
     */
    public function setOrderModel($orderModel)
    {
        $this->_orderModel = $orderModel;
    }

    /**
     * @return
     */
    public function getOrderStatusesModel()
    {
        return $this->_orderStatusesModel;
    }

    /**
     * @param  $orderStatusesModel
     */
    public function setOrderStatusesModel($orderStatusesModel)
    {
        $this->_orderStatusesModel = $orderStatusesModel;
    }

    /**
     * @return
     */
    public function getVerifoneModel()
    {
        return $this->_verifoneModel;
    }

    /**
     * @param  $verifoneModel
     */
    public function setVerifoneModel($verifoneModel)
    {
        $this->_verifoneModel = $verifoneModel;
    }

    /**
     * @return
     */
    public function getCustomerModel()
    {
        return $this->_customerModel;
    }

    /**
     * @param  $customerModel
     */
    public function setCustomerModel($customerModel)
    {
        $this->_customerModel = $customerModel;
    }

    /**
     * @return mixed
     */
    public function getDb()
    {
        return $this->_db;
    }

    /**
     * @param mixed $db
     */
    public function setDb($db)
    {
        $this->_db = $db;
    }

    /**
     * @return mixed
     */
    public function getVerifoneOrderStatus()
    {
        return $this->_verifoneOrderStatus;
    }

    /**
     * @param mixed $verifoneOrderStatus
     */
    public function setVerifoneOrderStatus($verifoneOrderStatus)
    {
        $this->_verifoneOrderStatus = $verifoneOrderStatus;
    }

}
