<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2019 Lamia Oy (https://lamia.fi)
 */


class Verifone_Upgrade
{
    public static function upgrade()
    {
        $setting = Verifone_Storage::getInstance()->getSettingModel();

        $settingVersion = $setting->getSetting('payment_verifone_db');

        if (isset($settingVersion['payment_verifone_db_version'])) {
            $installed_ver = $settingVersion['payment_verifone_db_version'];
        } else {
            $installed_ver = null;
        }

        if (version_compare($installed_ver, '1.2.1', '<')) {
            self::_upgradeTo121();
        }

        if (version_compare($installed_ver, '1.2.2', '<')) {
            self::_upgradeTo122();
        }


        if ($installed_ver !== ControllerExtensionPaymentVerifone::VERSION) {
            $setting->editSetting('payment_verifone_db', ['payment_verifone_db_version' => ControllerExtensionPaymentVerifone::VERSION]);
        }
    }

    protected static function _upgradeTo121()
    {
        $db = Verifone_Storage::getInstance()->getDb();

        $table_name = DB_PREFIX . 'verifone_order_process_status';

        $sql = "CREATE TABLE IF NOT EXISTS $table_name (
            `order_id` varchar(20) NOT NULL COMMENT 'Order Increment Id',
           `under_process` tinyint(1) NOT NULL COMMENT 'Order process status',
            PRIMARY KEY  (`order_id`)
        ) ENGINE=MyISAM DEFAULT COLLATE=utf8_general_ci;";

        $db->query($sql);

    }

    protected static function _upgradeTo122()
    {
        $db = Verifone_Storage::getInstance()->getDb();

        $code = 'verifone_create_order_email';
        $trigger = 'catalog/model/extension/payment/verifoneOrderStatus/addOrderHistory/after';
        $action = 'extension/payment/verifoneMail';
        $status = 1;
        $sort_order = 0;

        $db->query("INSERT INTO `" . DB_PREFIX . "event` SET `code` = '" . $db->escape($code) . "', `trigger` = '" . $db->escape($trigger) . "', `action` = '" . $db->escape($action) . "', `sort_order` = '" . (int)$sort_order . "', `status` = '" . (int)$status . "'");

        $actionAlert = $action . '/alert';
        $db->query("INSERT INTO `" . DB_PREFIX . "event` SET `code` = '" . $db->escape($code . '_alert') . "', `trigger` = '" . $db->escape($trigger) . "', `action` = '" . $db->escape($actionAlert) . "', `sort_order` = '" . (int)$sort_order . "', `status` = '" . (int)$status . "'");

    }
}