<?php
/**
 * NOTICE OF LICENSE
 *
 * This source file is released under commercial license by Lamia Oy.
 *
 * @copyright Copyright (c) 2019 Lamia Oy (https://lamia.fi)
 */


class Verifone_OrderLocker
{

    const TABLE_NAME = 'verifone_order_process_status';

    public static function lockOrder($orderId)
    {
        $db = self::getDb();
        $result = false;
        $tableName = self::_getTableName();

        try {
            $db->query('START TRANSACTION');

            $query = "SELECT * FROM $tableName WHERE order_id =  $orderId";
//            var_dump($db->query($query));
            if ($db->query($query)->num_rows) {
                $query = "UPDATE $tableName  SET `under_process` = '1' WHERE `order_id` = '$orderId' AND `under_process` = 0;";
                $result = $db->query($query) && $db->countAffected();
            } else {
                $query = "INSERT INTO $tableName (`order_id`, `under_process`) VALUES ('$orderId', 1)";
                $result = $db->query($query) && $db->countAffected();
            }

            $db->query('COMMIT');
        } catch (Exception $e) {
            $db->query('ROLLBACK');

        }

        return $result;
    }

    public static function unlockOrder($orderId)
    {
        $db = self::getDb();
        $result = false;
        $tableName = self::_getTableName();

        try {
            $db->query('START TRANSACTION');

            $query = "UPDATE $tableName  SET `under_process` = '0' WHERE `order_id` = '$orderId' AND `under_process` = 1;";
            $result = (bool)$db->query($query);

            $db->query('COMMIT');
        } catch (Exception $e) {
            $db->query('ROLLBACK');
        }

        return $result;
    }

    public static function isLockedOrder($orderId)
    {
        $db = self::getDb();

        $query = 'SELECT * FROM `' . self::_getTableName() . '` WHERE under_process = 1 AND order_id = ' . $orderId;
//        var_dump($db->query($query));
        if ($db->query($query)->num_rows) {
            return true;
        }

        return false;

    }

    public static function getDb()
    {
        return Verifone_Storage::getInstance()->getDb();
    }

    protected static function _getTableName()
    {
        return DB_PREFIX . self::TABLE_NAME;
    }
}